This file documents the Elisp package 'hm--html-menus'.

   Copyright (C) 1998 Heiko Münkel

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided also
that the sections entitled "Distribution" and "General Public License"
are included exactly as in the original, and provided that the entire
resulting derived work is distributed under the terms of a permission
notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that the sections entitled "Distribution" and "General
Public License" may be included in a translation approved by the author
instead of in the original English.

1 License
*********

Copyright (C) 1993 - 1998 Heiko Münkel, muenkel@tnt.uni-hannover.de

   This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

   This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

   You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

2 Overview
**********

This document describes the Elisp package _hm--html-menus 5.9_.

   The version of the document is:
$Id: hm-html-mode.texi,v 6.24 2003-06-27 18:50:36 adrian Exp $

   The package provides commands and various popup and pulldown menus
for an HTML mode called "hm--html-mode", a mode for writing HTML pages
for the World Wide Web (WWW). It also provides a minor mode
("hm--html-minor-mode"), which can be used together with other HTML
major modes, like the psgml-html mode in XEmacs 19.14 or other major
edit modes, like the perl-mode.

   You can easily view the HTML documents by calling the browsers w3 (a
nice elisp package from William M. Perry), Netscape, or Mosaic directly
from the pulldown menu of the mode.

   An integrated (emacs internal) drag and drop interface makes it very
easy to insert links or images, by just clicking on them.

   When appropriate, identical commands work on selected regions.
You'll see the same menu items and can use the same keystrokes, whether
a region is active or not, but if it's active, then the commands are
operating on the region.  Therefore, you don't need to learn different
menus or keys for similar functions!

   One major design goal of the package was to make it easier to write a
HTML page, even if you don't know much about HTML. For that I've tried
to put more knowledge about HTML, URL's and so on in it than an SGML
based mode could find out from a DTD file.  In most cases the user gets
help to construct a specific link by examples, or by a completion list
with possible input strings.  And you can choose between an expert popup
menu and an novice popup menu interactively.  The novice menu contains
only the basic HTML elements, so that you're not bothered by the
quantity of different HTML elements.  And if you want to use more HTML
elements, then you can easily switch to the expert menus.

   You can configure the html mode with a special configuration file for
your site and with another file specific to a user.  Look at the
customization chapter for this, see Customization.

3 Distribution
**************

The name of the distribution file is 'hm--html-menus-<version>.tar.gz',
where <VERSION> is the version number.  The package is part of the
XEmacs.  You should always find the latest version of the package on the
following ftp server:
     _ftp.tnt.uni-hannover.de_ in '/pub/editors/xemacs/contrib'
   You should also find the package in the USA on the ftp server (which
is mirrored on many other servers in the world):
     _sunsite.unc.edu_ in '/pub/Linux/apps/editors/emacs'

3.1 Contents
============

The package consists of the following files:

'README'
     Please, read this first.
'README-EMACS-19'
     Some special hints only for GNU Emacs 19 users.
'ANNOUNCEMENT'
     Text of the announcement of this package.
'LSM'
     Entry for the Linux Software Map.
'NEWS'
     The NEWS and Change log file.
'adapt.el'
     Provides (emulates XEmacs) functions for the use of this package
     with GNU Emacs 19.
'drop'
     An xbm file with the drag and drop mouse pointer in the XEmacs.
'dropmsk'
     An xbm file with the mask for the drag and drop mouse pointer in
     the XEmacs.
'hm--html.el'
     Provides functions to write html pages.  It defines all commands
     which insert html elements and entities.
'hm--html-indentation.el'
     Provides the lisp code for the indentation.
'hm--html-keys.el'
     Defines the key bindings.
'hm--html-menu.el'
     Provides the menus.
'hm--html-mode.el'
     Provides the functions for the definition of the hm-html-mode and
     the hm-html-minor-mode.  This is the main file of the package.
'hm--html-not-standard.el'
     Provides functions to insert some non standard html elements.  This
     file is not evaluated by default and it may be a bad idea to use
     it.
'hm--html-configuration.el'
     Configuration file for the html mode.  All the user variables are
     defined in this file.
'hm--html-drag-and-drop.el'
     Defines the HTML-specific functions for the drag and drop
     interface.
'hm--date.el'
     Defines the function hm-date, which returns the date in the format
     "day-month-year" like "30-Jun-1993".
'html-view.el'
     Ron Tapia's html-view.el to view html pages in Mosaic.  It is
     patched for use with XEmacs.
'internal-drag-and-drop.el'
     Provides the general (html-mode independent) functions of the drag
     and drop interface.
'templates.doc'
     Describes the syntax of the templates provided in the file
     'tmpl-minor-mode.el'
'tmpl-minor-mode.el'
     Provides functions for the tmpl-minor-mode.  With this mode you can
     expand templates, which are described in the file
     'templates-syntax.doc' (look at the files
     'command-description.html.tmpl' and 'frame.html.tmpl' for
     examples).  Templates can be expanded automatically, if you include
     a file with templates via the html pulldown menu item "Templates
     ..."  or with the item "Templates (fixed dirs)...".
'command-description.html.tmpl'
     Template file for the use with the tmpl-minor-mode.
'frame.html.tmpl'
     Template file, provides a simple frame.
'doc/hm--html-mode.texinfo'
     Package documentation in the Texinfo format.
'doc/umlaute.texinfo'
     Texinfo include file for German vowel mutation (deutsche Umlaute).

4 Installation
**************

  1. Put all the *.el files in one of your XEmacs (or emacs) lisp load
     directories (e.g.  site-lisp/hm-html-menus).

  2. _For XEmacs only_:
     Put the files 'drop' and 'dropmsk' in the directory specified by
     the lisp variable 'idd-data-directory'.  By default it is
     '<prefix>/lib/xemacs-<version>/etc/idd' (eg: if you have installed
     the XEmacs 19.15 at your site in '/usr/local', then it is the
     directory '/usr/local/xemacs/lib/xemacs-19.15/etc/idd'.

     If you'd like to put the files in another directory, then you must
     set the variable 'idd-data-directory' to this directory (eg, to put
     in the directory '/usr/local/data': '(setq idd-data-directory
     "/usr/local/data")'

  3. Put the following in your .emacs (or default.el or site-init.el):
          (autoload 'hm--html-mode "hm--html-mode" "HTML major mode." t)
          (autoload 'hm--html-minor-mode "hm--html-mode" "HTML minor mode." t)
          (or (assoc "\\.html$" auto-mode-alist)
              (setq auto-mode-alist (cons '("\\.html$" . hm--html-mode)
          				auto-mode-alist)))

          (autoload 'tmpl-expand-templates-in-buffer "tmpl-minor-mode"
            "Expand all templates in the current buffer." t)
          (autoload 'tmpl-expand-templates-in-region "tmpl-minor-mode"
            "Expands the templates in the region from BEGIN to END.
          If BEGIN and END are nil, then the current region is used."
            t)
          (autoload 'tmpl-insert-template-file-from-fixed-dirs
                    "tmpl-minor-mode"
            "Inserts a template FILE and expands it, if
          `tmpl-automatic-expand' is t.
          This command tries to read the template file from a list of
          predefined directories (look at `tmpl-template-dir-list') and it
          filters the contents of these directories with the regular
          expression `tmpl-filter-regexp' (look also at this variable).
          The command uses a history variable, which could be changed with the
          variable `tmpl-history-variable-name'.

          The user of the command is able to change interactively to another
          directory by entering at first the string \"Change the directory\".
          This may be too difficult for the user. Therefore another command
          called `tmpl-insert-template-file' exist, which doesn't use fixed
          directories and filters."
            t)

          (autoload 'tmpl-insert-template-file "tmpl-minor-mode"
            "Inserts a template FILE and expand it,
          if `tmpl-automatic-expand' is t.
          Look also at `tmpl-template-dir-list', to specify a default template
          directory. You should also take a look at
          `tmpl-insert-template-file-from-fixed-dirs', which has additional
          advantages (and disadvantages :-).

          ATTENTION: The interface of this function has changed. The old
          function had the argument list
                  (&optional TEMPLATE-DIR AUTOMATIC-EXPAND).
          The variables `tmpl-template-dir-list' and `tmpl-automatic-expand'
          must now be used instead of the args TEMPLATE-DIR and
          AUTOMATIC-EXPAND."
            t)

          (autoload 'html-view-start-mosaic "html-view" "Start Xmosaic." t)
          (autoload 'html-view-view-buffer
            "html-view"
            "View the current buffer in Xmosaic."
            t)
          (autoload 'html-view-view-file
            "html-view"
            "View a file in Xmosaic."
            t)
          (autoload 'html-view-goto-url
            "html-view"
            "Goto url in Xmosaic."
            t)
          (autoload 'html-view-get-display
            "html-view"
            "Get the display for Xmosaic (i.e. hostxy:0.0)."
            t)

     The above lines assume that you have not already installed another
     html mode.  If this isn't true, then you should use the following:
          (setq auto-mode-alist (cons '("\\.html$" . hm--html-mode)
                                      auto-mode-alist))

     instead of:
          (or (assoc "\\.html$" auto-mode-alist)
              (setq auto-mode-alist (cons '("\\.html$" . hm--html-mode)
          			        auto-mode-alist)))
     If you want to use the hm-html-minor-mode together with the
     psgml-html modes, then you should add the following line (works
     only in XEmacs version >= 19.15 and != 20.0):
          (add-hook 'html-mode-hook 'hm--html-minor-mode)

5 Customization
***************

You should be able to use the package after its installation without any
further customization.  But it contains a lot of user variables to adapt
the package better to your special needs.  How to do this is described
in this chapter.

   Since the XEmacs 19.15 and 20.2 a special package can be used for the
customization of lisp packages.  This package uses now also this
feature.  Therefore you can set all user variables with the help of the
Customize submenu, which can be selected in the Option menu.  If you use
it, the variables will currently be saved in a special customization
file and not in one of the configuration files (see Customization (Configuration) Files)
of this
package.  Please look at the 'NEWS' file or the info manuals of the
XEmacs to find out more about the customization package.

5.1 Customization (Configuration) Files
=======================================

This package uses 3 different files to customize the mode, but you need
not use all of them.  Only one of them, the file
'hm--html-configuration.el' is delivered together with the package.  The
reason for three different files is to provide the opportunity to have
different customization for the package, the site and the user.  There's
also a pulldown menu item to reload all customization files.  The files
are described in the following sections.

5.1.1 Where Are All The Customization Variables Defined
-------------------------------------------------------

All variables which can be used to customize the mode are defined in the
package configuration file 'hm--configuration.el'.  You should take a
look at this file if you don't find how to customize a feature in this
documentation (the documentation of a program is never as complete as
its program code :-).

   This file is searched in one of your lisp load directories.  You can
change this by setting the environment variable 'HTML_CONFIG_FILE' to
another file.  But I don't recommend this.

   _Note_: This file is loaded before the other customization files, so
that its definitions could be overwritten.  All variables are set by
'defvar', so that its values could also be overwritten with 'setq' in
any standard emacs customization files (e.g.  in '.emacs').

5.1.2 Where To Put Site Specific Customization
----------------------------------------------

In general all users at a site are writing their html pages for the same
WWW server.  Therefore it is very likely that most of the customizations
are site specific, and only a few are user specific.  However, you don't
have to use a site specific customization if you don't want one.

   If you'd like to make a site specific customization of
'hm--html-mode', it's possible to put it in a special file called
'hm--site-configuration-file.el'.  If you do this, you have to set
either the lisp variable 'hm--html-site-config-file' or the environment
variable 'HTML_SITE_CONFIG_FILE' to the file and its path.  If you write
the filename without its extension (.el), emacs tries first to load a
compiled version of the file.

   The environment variables overwrite the lisp variables.

   You can prevent the loading of the site specific customization file
by starting the emacs with the -no-site-file flag.

   You can also put the site specific customization in any standard
emacs customization file like, 'default.el'.  But an advantage to using
'hm--site-configuration-file.el' is that it is very likely you will be
able to use this file with future versions of the package.  I'll try to
make it as backward compatible as possible.

   _Note_: This file is loaded after the package customization file and
before the user customization file.

5.1.3 Where To Put User Specific Customization
----------------------------------------------

User specific customization can be put in the file
'.hm--html-configuration.el', which is searched by default in the home
directory of the user.  This can be overwritten by setting either the
environment variable 'HTML_USER_CONFIG_FILE' or the lisp variable
'hm--html-user-config-file' to the name of the file and its path.  If
you write the filename without its extension (.el), emacs tries first to
load a compiled version of the file.

   If neither the environment variable nor the lisp variable is set, the
variable 'init-file-user' will be respected.  Therefore you'll get
'~other-user/.hm--html-configuration.el', if you've started the emacs
with the options '-u other-user'.  In all cases, no user specific
customization file will be loaded, if the '-q' option was given to the
emacs.

   You can also put the user specific customization in your '.emacs'.
It's up to you to decide which way is better.

   _Note_: This file is loaded after the package and the site specific
one.  Therefore it overwrites all other customization files.

5.2 Customization Variables
===========================

In the following subsections the main customization variables are
described.

5.2.1 User Name/Signature
-------------------------

   * 'hm--html-username': Your real name.  This is used as the name of
     the signature links.  You need only specify it if your name in the
     file '/etc/passwd' isn't the one you'd like to see in the html
     files.  Otherwise this may be set to 'nil'.
   * 'hm--html-signature-file': The link used in your signature.  In
     general this should be a link to your home page.

5.2.2 Switching Between Expert And Novice Menus
-----------------------------------------------

   * 'hm--html-expert': If you're a html novice and don't want to be
     bothered with lots of possible html elements, then you should use
     the novice popup menus.  For that, set this variable to 'nil',
     which is the default.  But if you are more familiar with html and
     would like to use more html elements, then you should use the
     expert menus and set this variable to 't'.

5.2.3 HTML Doctype
------------------

   * 'hm--html-html-doctype-version': The HTML version.  This is used in
     the doctype element.  Change this if you use non HTML 3.2 elements.
     This package (see version.)  defines by default only
     HTML 3.2 elements.

5.2.4 Defaults Used For Generating Links
----------------------------------------

One of the main features of 'hm--html-mode' is its easy ways to insert
special links to html pages, ftp servers, news servers and so on.  I
think that most people will have their own (this may be site specific.
See Where To Put Site Specific Customization.)
favourite servers, directories and so on.  You
may customize the default values and the alists with useful
alternatives, which are used from the mode in the inserting functions
for the links.

5.2.4.1 Your Favourite HTTP Server
..................................

   * 'hm--html-favorite-http-server-host-name': The name of your
     favorite http server host.  It must be specified!  This variable is
     used in many other variables.

5.2.4.2 Links to WWW Server
...........................

   * 'hm--html-html-hostname:port-default': Default hostname with port
     for http links to a HTML server.
   * 'hm--html-html-hostname:port-alist': Alist with hostnames and ports
     for http links to HTML servers.  It contains useful alternatives.
   * 'hm--html-html-path-alist': Alist with directories for the HTML
     server.  Each alist element must consist of a number and a
     directory string.  The number is used to select the directory
     during the query about the directory for an http link.

5.2.4.3 Links To Files
......................

   * 'hm--html-file-path-alist': Alist with directories for the file
     gateway.  Each alist element must consist of a number and a
     directory string.  The number is used to select the directory
     during the query about the directory for a file link.

5.2.4.4 Links To FTP Servers
............................

   * 'hm--html-ftp-hostname:port-default': Default hostname with port
     for links to an ftp server.  This is for the default FTP server.
     In general you don't need to specify a port for this.
   * 'hm--html-ftp-hostname:port-alist': Alist with hostnames and ports
     for links to ftp servers.  It contains useful alternatives.  In
     general you don't need to specify ports for the ftp servers.
   * 'hm--html-ftp-path-alist': Alist with directories for the ftp
     server links.  It contains useful alternatives with /pub, /pub/gnu
     and so on.  Each alist element must consist of a number and a
     directory string.  The number is used to select the directory
     during the query about the directory for an ftp link.

5.2.4.5 Links To Emacs Info Files
.................................

   * 'hm--html-info-hostname:port-default': Default hostname with port
     for the Info gateway.
   * 'hm--html-info-hostname:port-alist': Alist with hostnames and ports
     for Info gateways.  It contains useful alternatives.
   * 'hm--html-info-path-alist': Alist with directories for the Info
     gateway.  This may be a list with all of your emacs info
     directories.

5.2.4.6 Links To Gopher Servers
...............................

There are a lot of useful gopher information servers on the Internet.
You can access them with a gopher browser or with a WWW browser.  In the
latter case you have to use the gopher gateway.

   * 'hm--html-gopher-hostname:port-default': Default hostname with port
     for links to the default gopher server.
   * 'hm--html-gopher-hostname:port-alist': Alist with hostnames and
     ports for links to gopher servers.  It contains useful
     alternatives.
   * 'hm--html-gopher-doctype-default': For gopher links you have to
     specify the doctype.  In most cases this should be the string
     \"/1\".  Therefore this is the default doctype, but you can change
     it to another.
   * 'hm--html-gopher-doctype-alist': Alist with doctype strings for
     links to a gopher server.  The strings \"/1\", \"/11\" and \"/00\"
     are the only doctype strings that I know.  Please let me know if
     there are other strings.
   * 'hm--html-gopher-anchor-alist': Alist with directories for links to
     a gopher server.  It contains useful alternatives for the main
     gopher servers.  Each alist element must consist of a number and a
     directory string.  The number is used to select the directory
     during the query about the directory for a local program gateway
     link.

5.2.4.7 Links To WAIS Gateways
..............................

You can either make a link direct to a WAIS server (it may be that not
all WWW browsers support this) or an http link to a server (relay host)
which queries the WAIS server.  The variables
'hm--html-wais-hostname:port-default' and 'hm--html-wais-hostname' refer
to these relay hosts and the variables
'hm--html-wais-servername:port-default' and
'hm--html-wais-servername:port-alist' refer to the WAIS servers.

   * 'hm--html-wais-hostname:port-default': Default hostname of the
     relay host with port for the WAIS gateway.
   * 'hm--html-wais-hostname:port-alist': Alist with hostnames of
     possible relay hosts and ports for the WAIS gateway.  It contains
     useful alternatives.
   * 'hm--html-wais-servername:port-default': Default WAIS servername
     with port for the WAIS gateway.
   * 'hm--html-wais-servername:port-alist': Alist with WAIS servernames
     and ports for the WAIS gateway.  It contains useful alternatives.
   * 'hm--html-wais-path-alist': Alist with directories for the wais
     gateway.

5.2.4.8 Links To The Mail Gateway
.................................

The following variables are for customizing the insertion of links to a
mail folder.  You need a special server for this, which sends the email
back to the browser.

   * 'hm--html-mail-hostname:port-default': Default hostname with port
     for the mail gateway.
   * 'hm--html-mail-hostname:port-alist': Alist with hostnames and ports
     for the mail gateway.  It contains useful alternatives.
   * 'hm--html-mail-path-alist': Alist with directories for the mail
     gateway.  In these directories you'll probably find mail folders.
     Each alist element must consist of a number and a directory string.
     The number is used to select the directory during the query about
     the directory for a mail folder link.

5.2.4.9 Links For Sending Mail
..............................

   * 'hm--html-mailto-alist': Alist with mail addresses for the mailto
     alist.  The value of 'user-mail-address' will also be added by the
     package to this alist.

5.2.4.10 Links to CGI scripts
.............................

CGI scripts are available on many WWW servers to start special programs
(eg: cgi-man, to display man pages).  Creating these links can be
customized with the following varoables.

   * 'hm--html-cgi-hostname:port-alist': Alist with hostnames and ports
     for the cgi server.
   * 'hm--html-cgi-hostname:port-default': Default hostname with port
     for the cgi server.
   * 'hm--html-cgi-script-alist': Alist with CGI scripts, which are
     available on your server.
   * 'hm--html-cgi-script-default': Default CGI script.

5.2.4.11 Links To The Program Gateway
.....................................

The program gateway is a special TNT site specific gateway for starting
programs out of a html page.  The programs are started by a special
server, which looks in an allowed file to determine if it is allowed to
start the program.  This is necessary because the programs are running
under the user id of the server.  We're only allowed to start simple
display programs like man, ls and so on.

   * 'hm--html-proggate-hostname:port-default': Default hostname with
     port for the proggate server.
   * 'hm--html-proggate-hostname:port-alist': Alist with hostnames and
     ports for the proggate server.  It contains useful alternatives.
   * 'hm--html-proggate-allowed-file': The filename (with path) of the
     proggate allowed file.

5.2.4.12 Links To The Local Program Gateway
...........................................

Another TNT site specific way to start programs from a html page.  These
programs are started with the id of the user on the host where the
client (browser) is running.  Therefore no restriction about the allowed
programs is made.  With this you can start only programs and do only
things, which you can do also without the WWW browser.

   * 'hm--html-local-proggate-path-alist': Alist with directories for
     the local program gateway.  Contains directories, where you can
     find programs.

5.2.4.13 URL For Forms And Image Tags
.....................................

   * 'hm--html-url-alist': Alist with URL's for FORMS and IMAGE tags.
     The cdr of each list contains symbols, which specifies the use of
     the URL.

5.2.4.14 Marking Of Examples
............................

The following variables are for marking the examples in the help buffer.

   * 'hm--html-help-foreground': The foreground color for highlighting
     examples.
   * 'hm--html-help-background': The background color for highlighting
     examples.
   * 'hm--html-help-font': The font for highlighting examples.

5.2.5 Templates
---------------

For inserting html template files you can customize where you keep your
templates.

   * 'hm--html-template-dir': A directory with template files.  It is
     now also possible to use it as a list of directories.  Look at the
     variable 'tmpl-template-dir-list' for further descriptions.  If
     this variable is set to a non-existent directory, then it defaults
     to the directory where the package is in XEmacs.  This is done
     during loading the file 'hm--html-configuration.el' (see Where Are All The Customization Variables Defined.).
     This may only be useful in
     XEmacs >= 19.12.
   * 'hm--html-frame-template-file': File which is used as template for
     a html frame.  An example is in the package _hm-html-menus_.  See
     Contents.
   * 'hm--html-automatic-expand-templates': Automatic expansion of
     templates.  This feature needs the file 'tmpl-minor-mode.el' from
     Heiko Münkel ('muenkel@tnt.uni-hannover.de'), which is distributed
     with the package hm-html-menus.
   * 'hm--html-template-filter-regexp': Regexp for filtering out non
     (html) template files in a directory.

5.2.6 Deleting Automounter Path Prefix
--------------------------------------

   * 'hm--html-delete-wrong-path-prefix': If non-nil, it specifies
     path-prefixes which should be deleted in paths.  The Sun
     automounter adds a temporary prefix to the automounted directories
     (at our site the prefix is /tmp_mnt).  But you can't select such a
     path if the automounter has currently not mounted the directory,
     and so you can't follow an html link which consists of such a path.
     To overcome this behaviour, you can set this variable to the prefix
     (e.g.  "/tmp_mnt").  After that, the prefix should be stripped from
     the paths during the creation of the links.  ATTENTION: This
     variable is used as a regular expression!  It can be set to a
     string or to a list of strings.

5.2.7 Automatic Insert Of Information
-------------------------------------

The 'hm--html-mode' automatically inserts some useful information in
html pages.  This behaviour can be changed by the following variables.

   * 'hm--html-automatic-create-title-date': t => A date string will be
     inserted in the title line.  This will be updated each time before
     file saving, if 'hm--html-automatic-update-title-date' is also set
     to t.
   * 'hm--html-automatic-update-title-date': t => The date in the title
     line will be updated before file saving.  nil => No automatic
     update of the date.
   * 'hm--html-title-date-format': Default output format for date and
     time in the title and main header line.  _WARNING_: Don't use the
     character _<_ in this string!  The format is used as argument of
     the function 'format-time-string'.  The following describes the
     meanings of special %-sequences, as described in the function
     documentation of 'format-time-string':

        * '%a' This stands for the abbreviated name of the day of week.
        * '%A' This stands for the full name of the day of week.
        * '%b' This stands for the abbreviated name of the month.
        * '%B' This stands for the full name of the month.
        * '%c' This is a synonym for '%x %X'.
        * '%C' This has a locale-specific meaning.  In the default
          locale (named C), it is equivalent to '%A, %B %e, %Y'.
        * '%d' This stands for the day of month, zero-padded.
        * '%D' This is a synonym for '%m/%d/%y'.
        * '%e' This stands for the day of month, blank-padded.
        * '%h' This is a synonym for '%b'.
        * '%H' This stands for the hour (00-23).
        * '%I' This stands for the hour (00-12).
        * '%j' This stands for the day of the year (001-366).
        * '%k' This stands for the hour (0-23), blank padded.
        * '%l' This stands for the hour (1-12), blank padded.
        * '%m' This stands for the month (01-12).
        * '%M' This stands for the minute (00-59).
        * '%n' This stands for a newline.
        * '%p' This stands for 'AM' or 'PM', as appropriate.
        * '%r' This is a synonym for '%I:%M:%S %p'.
        * '%R' This is a synonym for '%H:%M'.
        * '%S' This stands for the seconds (00-60).
        * '%t' This stands for a tab character.
        * '%T' This is a synonym for '%H:%M:%S'.
        * '%U' This stands for the week of the year (01-52), assuming
          that weeks start on Sunday.
        * '%w' This stands for the numeric day of week (0-6).  Sunday is
          day 0.
        * '%W' This stands for the week of the year (01-52), assuming
          that weeks start on Monday.
        * '%x' This has a locale-specific meaning.  In the default
          locale (named C), it is equivalent to '%D'.
        * '%X' This has a locale-specific meaning.  In the default
          locale (named C), it is equivalent to '%T'.
        * '%y' This stands for the year without century (00-99).
        * '%Y' This stands for the year with century.
        * '%Z' This stands for the time zone abbreviation.

   * 'hm--html-log-date-format': Default output format string for date
     and time in the log lines.  _WARNING_: Don't use the character _<_
     in this string!  The log lines are the lines with the created and
     changed comments.  The format string is used as argument of the
     function 'format-time-string'.  Please look at the description of
     the function 'format-time-string' or of the variable
     'hm--html-title-date-format' for a description of the format
     string.
   * 'hm--hmtl-include-time-after-date': This variable isn't longer
     supported.  It is replaced by 'hm--html-log-date-format'.  It's old
     description was:

     t => The time of day will be appended to the date in the created
     and changed comment lines, as well as in the visible modified line
     if these lines are present; the time will never be appended to the
     date in the title.  The separator between date and title is defined
     with 'hm--html-date-time-separator'.
   * 'hm--html-date-time-separator': This variable isn't longer
     supported.  It is replaced by 'hm--html-log-date-format'.  It's old
     description was:

     The value of the separator between date and time in the created and
     modified comment lines and in the visible modified line.  This is
     only used if 'hm--hmtl-include-time-after-date' is t.  Eg.: " at ".
   * 'hm--html-automatic-created-comment': t => A "created comment" line
     will be added.  nil => No automatic insert of a "created comment"
     line.
   * 'hm--html-created-comment-prefix': The prefix text of the "created
     comment" lines.  By default this is set to "Created by: ".
   * 'hm--html-comment-infix': The infix (second part) of the "created
     comment" and the "changed comment" lines.  By default, if this
     variable is nil, the value of 'hm--html-username' or, if this
     variable is also nil, the return value of '(user-full-name)' will
     be used.  In these cases the infix looks like "Heiko Münkel, ".

     Set it to an empty string, if you don't want to have your name in
     the comments.
   * 'hm--html-automatic-changed-comment': t => A "changed comment" line
     will be added before file saving.  nil => No automatic insert of a
     "changed comment" line.
   * 'hm--html-changed-comment-prefix': The prefix text of the "changed
     comment" lines.  By default this is set to "Changed by: ".
   * 'hm--html-automatic-create-modified-line': t => Some commands will
     insert a visible "modified" line with the current date, if such a
     line does not exist already.  If it already exist, the date in the
     line will be updated.  Visible means, that it is not a HTML
     comment.  By default it looks like the following: '<EM>Modified
     24-May-1997</EM>'
   * 'hm--html-automatic-update-modified-line': t => The visible
     "modified" line will be updated with the current date before file
     saving.  If such a line does not exist, nothing will be done.
   * 'hm--html-modified-prefix': Prefix of the "modified" line.  By
     default it is set to '"Modified: "'.
   * 'hm--html-modified-start-tag': Start tag of the modified line.  By
     default it is '<EM>'.  If you change this, you'll need to change
     also 'hm--html--modified-end-tag'.
   * 'hm--html-modified-end-tag': End tag of the modified line.  By
     default it is '</EM>'.  If you change this, you'll need to change
     also 'hm--html-modified-start-tag'.
   * 'hm--html-modified-insert-before': The "modified line" will be
     inserted before this string.  The search will be done from the end
     to the beginning.  And the "modified line" will be put at least
     before the '</HTML>' and the '</BODY>' tags.

5.2.8 Latin 1 Characters
------------------------

   * 'hm--html-bind-latin-1-char-entities': Set this to nil, if you
     don't want to use the ISO Latin 1 character entities.  This is only
     useful if 'hm--html-use-old-keymap' is set to nil.  It is only used
     when loading the html package the first time.

5.2.9 Drag And Drop
-------------------

   * 'hm--html-idd-create-relative-links': If t, then the
     'hm--html-idd-*' functions create relative links.  Otherwise
     absolute links are used.  The idd functions are used for drag and
     drop.
   * 'hm--html-idd-actions': The action list for the destination mode
     'hm--html-mode'.  Look at the description of the variable
     idd-actions.

5.2.10 Font Lock Keywords
-------------------------

   * 'hm--html-font-lock-keywords-1': Subdued level highlighting for
     'hm--html-mode'.
   * 'hm--html-font-lock-keywords-2': Gaudy level highlighting for
     'hm--html-mode'.
   * 'hm--html-font-lock-keywords': Default expressions to highlight in
     the 'hm--html-mode'.

5.2.11 Prefix Keys
------------------

   * 'hm--html-minor-mode-prefix-key': The prefix key for the key tables
     in the minor mode 'hm--html-minor-mode'.
   * 'hm--html-mode-prefix-key': The prefix key for the keys in the
     major mode 'hm--html-mode'.

5.2.12 Pulldown Menu Names
--------------------------

Perhaps you'd like to change the names to get the same menu names in the
major and in the minor modes of the 'hm--html-menus' package.

   * 'hm--html-mode-pulldown-menu-name': The name of the pulldown menu
     in the major html mode.
   * 'hm--html-minor-mode-pulldown-menu-name': The name of the pulldown
     menu in the minor html mode.

5.2.13 Hook Variables
---------------------

You may use the following two variables, if you'd like to call special
functions each time the major html mode is entered or the package is
loaded.

   * 'hm--html-mode-hook': This hook will be called each time
     'hm--html-mode' is invoked.
   * 'hm--html-load-hook': Hook variable to execute functions after
     loading the package.

5.2.14 Previewing HTML Files
----------------------------

The following two variables are only used, if you preview html documents
with 'Mosaic'.  There are also some other variables in 'html-view.el'.
See Contents.  Look at that file if you have trouble with
the functions to preview the html document with 'Mosaic'.

   * 'html-view-mosaic-command': The command that runs 'Mosaic' on your
     system.
   * 'html-sigusr1-signal-value': Value for the SIGUSR1 signal on your
     system.  See, usually, '/usr/include/sys/signal.h'.
          	SunOS 4.1.x	: (setq html-sigusr1-signal-value 30)
          	SunOS 5.x	: (setq html-sigusr1-signal-value 16)
          	Linux		: (setq html-sigusr1-signal-value 10))

5.2.15 Meta Element
-------------------

   * 'hm--html-meta-name-alist': Alist with possible names for the name
     or http-equiv attribute of meta.  Currently I know of the names
     'Expires', 'Keys' and 'Author'.  Please send me
     (_muenkel@tnt.uni-hannover.de_) an email, if you know other
     standard html names for the meta element.

5.2.16 Indentation
------------------

   * 'hm--html-disable-indentation': Set this to t if you want to
     disable indentation in 'hm--html-mode'.  And maybe send me
     (_muenkel@tnt.uni-hannover.de_) a note why you did this.
   * 'hm--html-inter-tag-indent': The indentation after a start tag.
   * 'hm--html-comment-indent': The indentation of a comment.
   * 'hm--html-intra-tag-indent': The indentation after the start of a
     tag.
   * 'hm--html-tag-name-alist': An alist with tag names known by
     'hm--html-mode'.  It is used to determine if a tag is a one element
     tag or not.  In the future it should also be used to get possible
     parameters of the tag.  Use lower case characters in this list!!!!
     If you have problems with the indentation of
     ':hm--html-one-or-two-element-tag' elements, then you should set
     them to either ':hm--html-one-element-tag' or
     ':hm--html-two-element-tag', depending on how you use these
     elements.  In the future I'll try to implement a better indentation
     for these elements.

6 Add New Elements
******************

If you'd like to add new HTML elements to this package, you should first
take a look at the file 'hm--html-not-standard.el', which already
contains some non-standard elements.  If you find your tags there, you
should uncomment the line '(require 'hm--html-not-standard)' in the file
'hm--html-mode.el'.  There are also menu entries for these elements in
the file 'hm--html-menu.el', which are commented out.  Don't forget to
recompile the changed lisp files after that!

   If you don't find your new elements there, you should do the
following steps to add them:

  1. Locate a tag which is similar to the one you want to add.
     "Similar" means that it is inserted in the way you want to insert
     the new tags.  Now let's assume, that you chose
     '<strong></strong>'.
  2. Look at the file 'hm--html.el' and search the function(s) which
     inserts the similar tag(s).  If the HTML element consists of only
     one tag, then there should be only one function for inserting the
     tag.  If the element consists of a start and an end tag, there are
     at least two functions.  Only in some special cases, if it is
     possible to insert elements with different attribute values, are
     there more than two functions.  In the case of '<strong></strong>',
     there are the two functions 'hm--html-add-strong' and
     'hm--html-add-strong-to-region'.  The first one is used if no
     region is active, and the second if a region is active.  The naming
     scheme of these functions is always HM-HTML-ADD-<TAGNAME> and
     HM-HTML-ADD-<TAGNAME>-TO-REGION.  <TAGNAME> is not in all cases the
     tagname.  Sometimes a more human readable name is used (e.g.  bold
     instead of b).
  3. To get the right indentation for the new tags you should add an
     entry for them to the alist of the variable
     'hm--html-tag-name-alist', which is defined in the file
     'hm--html-configuration.el'.  Let's assume that the new tagname is
     'foo'.  The entry in 'hm--html-tag-name-alist' should be
               ("foo" (:hm--html-one-element-tag t))
     if the new element consists only of one tag ('img' is such an
     element) or
               ("foo" (:hm--html-two-element-tag t))
     if the new element consists of two tags ('strong' is such an
     element) or
               ("foo" (:hm--html-one-or-two-element-tag t))
     if the new element consists of two tags, but it is permissible to
     use the start tag without its end tag ('p' is such an element).

   Now you are ready and able to insert the new tags with
     	M-x hm--html-add-foo
   and
     	M-x hm--html-add-foo-to-region

   If you want to add the new commands also to the popup menu, then you
have to take a look at 'hm--html-menu.el', where all the menus are
defined.  Look at 'hm--html-menu-noregion-expert' and
'hm--html-menu-region-expert'.  The first one is used if no region is
active, and the second if a region is active (both are only available if
the "expert menus" are used; this is an option in the pulldown menu).
You should now add an entry like
     	["Foo" hm--html-add-foo t]
   to the 'hm--html-menu-noregion-expert' variable and an entry
     	["Foo" hm--html-add-foo-to-region t]
   to the 'hm--html-menu-region-expert' variable (only if
'hm--html-add-foo-to-region' exists).  You can do this by setting the
whole variable to a new value or by using the function
'add-menu-button'.  I recommend the last method.

   If you'd like to have a key sequence for inserting the new tag as
well, take a look at 'hm--html-keys.el'.  There are different key tables
defined for region and no region cases and for different sorts of
elements, like anchors, frame elements (doesn't mean the Netscape
element frame) and so on.  These "groups" are the same as the submenu
groups.

7 Use With Other Major Modes
****************************

The package provides a minor mode called 'hm--html-minor-mode', which
could be used to join the features of this package with other HTML
packages or use it's features in other major edit modes.  This is
useful, if you'd like to extend another HTML mode or if you'll write
program code, which contain HTML parts.

   Currently this is tested with the psgml-html mode, the 'perl-mode'
and the 'java-mode'.  Please let me know if it works or not with other
packages.

   If you'd like to use the minor mode in psgml-html mode, put the
following line in your '.emacs':

          (add-hook 'html-mode-hook 'hm--html-minor-mode)

   Note: This should work only in XEmacs versions greater than 19.14 and
not in 20.0.  It doesn't work in other versions because the hook
variable 'html-mode-hook' doesn't exist in those versions.  Therefore in
those versions you must either call the minor mode by hand or change the
lisp file of the psgml-html mode.

8 Internal Drag And Drop
************************

The file 'internal-drag-and-drop.el', which is shipped with
'hm--html-menus', provides a general package for internal drag and drop
in emacs.  "General" means that it can be used apart from
'hm--html-mode' in any other mode.

   You can start such an action by clicking with the mouse in the source
buffer and then in the destination buffer.  The action may depend on the
points where you've clicked with the mouse, on the state of the region,
the point, the mark and any other properties of the source and the
destination buffers.  The actions are defined by the variable
'idd-actions', which is a buffer local variable.

8.1 Drag And Drop Customization
===============================

Since the XEmacs 19.15 and 20.2 a special package can be used for the
customization of lisp packages.  The internal drag and drop package uses
now also this feature.  Therefore you can set all user variables with
the help of the Customize submenu, which can be selected in the Option
menu.  If you use it, the variables will currently be saved in a special
customization file.  Please look at the 'NEWS' file or the info manuals
of the XEmacs to find out more about the customization package.

   The internal drag and drop functions may be used in all modes.
Therefore their general customization isn't done in
'hm--html-configuration.el'.  Its variables are defined in the file
'internal-drag-and-drop.el' instead.  You can set them in your '.emacs'
or in one of the other emacs init files (e.g.  'default.el').  The
following subsections describe the main customization variables.

8.1.1 Defining The Drag And Drop Actions
----------------------------------------

The drag and drop actions are commands which are called after an
internal drag and drop.  They depend on the source and the destination
of the drag and drop.  Drag and drop actions are defined by the
variable:

   * 'idd-actions': A list with actions, depending on the source and the
     destination of the drag and drop command.

   The list looks like:
     '((<DESTINATION-SPECIFICATION-1> (<SOURCE-SPECIFICATION-1> <ACTION-1-1>)
                                 (<SOURCE-SPECIFICATION-2> <ACTION-1-2>)
                                                 :
        )
       (<DESTINATION-SPECIFICATION-2> (<SOURCE-SPECIFICATION-1> <ACTION-2-1>)
                                 (<SOURCE-SPECIFICATION-2> <ACTION-2-2>)
                                                 :
        )
                               :
       )
   The <SOURCE-SPECIFICATION> looks like the following:
     '([(<SPECIFICATION-TYPE> <VALUE>)])
   with
     <SPECIFICATION-TYPE> :==
          idd-if-minor-mode-p | idd-if-buffer-name-p |
          idd-if-region-active-p | idd-if-url-at-point-p |
          idd-if-major-mode-p | idd-if-variable-non-nil-p |
          idd-if-dired-file-on-line-p |
          idd-if-dired-no-file-on-line-p |
          idd-if-local-file-p | idd-if-buffer-name-p |
          idd-if-modifiers-p | ...

   The <SPECIFICATION-TYPE> - functions must have two arguments.  The
first one is the source or destination and the second is the <VALUE>.
It must return 'nil', if the test wasn't successful, and a number (in
general 1), which specifies the weight of the test function.  The
weights of all single tests are added to a summary weight and assigned
to the action.  The action with the highest weight is called from the
action handler.  Look at the definition of 'idd-if-major-mode-p',
'idd-if-minor-mode-p' and so on for examples.  Look at the function
'idd-get-source-or-destination-alist', if you want to know the structure
of the 'source-or-destination' argument of these functions.

   The <DESTINATION-SPECIFICATION> looks like <SOURCE-SPECIFICATION>,
but in general it could be set to 'nil' in mode specific idd-action
lists.

   If <DESTINATION-SPECIFICATION-1> or <SOURCE-SPECIFICATION-1> is set
to 'nil', then every source or source matches.  'idd-actions' is a
buffer local variable, which should be at least mode depended.  So if
the <DESTINATION-SPECIFICATION-1> is set to 'nil' it says, that the
destination buffer must only have a specific mode.  However, it's also
possible to define a general 'idd-actions' list, where the destination
mode is specified by 'idd-if-major-mode-p'.

   <ACTION> is a function which has two arguments.  The first specifies
the source and the second the destination.  Look at the function
definition of 'idd-action-copy-region' and
'idd-action-copy-replace-region'.  They are examples for such actions.

   The following is an example for 'hm--html-mode':

     (defvar idd-actions
       '((nil (((idd-if-major-mode-p . dired-mode)
                (idd-if-dired-file-on-line-p . ".*\\.\\(gif\\)\\|\\(jpq\\)"))
               hm--html-idd-add-include-image-from-dired-line)
              (((idd-if-major-mode-p . dired-mode)
                (idd-if-dired-no-file-on-line-p . nil))
               hm--html-idd-add-file-link-to-file-on-dired-line)
              (((idd-if-major-mode-p . dired-mode)
                (idd-if-dired-no-file-on-line-p . t))
               hm--html-idd-add-file-link-to-directory-of-buffer)
              (((idd-if-major-mode-p . w3-mode)
                (idd-if-url-at-point-p . t))
               hm--html-idd-add-html-link-from-w3-buffer-point)
              (((idd-if-major-mode-p . w3-mode))
               hm--html-idd-add-html-link-to-w3-buffer)
              (((idd-if-local-file-p . t))
               hm--html-idd-add-file-link-to-buffer)))

8.1.2 The Mouse Bindings
------------------------

The following three variables determine the mouse bindings and the mouse
behaviour for the internal drag and drop package:

   * 'idd-global-mouse-keys': The mouse keys for the command
     'idd-mouse-drag-and-drop'.  The command 'idd-mouse-drag-and-drop'
     is bound during the loading of the package 'internal-drag-and-drop'
     to these keys in the global keymap.  The drag and drop action must
     be bound global, because the drag and drop action must be started
     by a click in the source buffer.  Therefore no action will be
     performed if the mouse keys are not bound to
     'idd-mouse-drag-and-drop' in the destination buffer.

     Set it to 'nil', if you don't want to bind this function during
     loading.

     If the command is already bound in the global keymap during
     loading, then this key sequence will not be bound.

     By default the mouse binding is <meta> <control> <button1>.

   * 'idd-global-help-mouse-keys': The mouse keys for the command
     'idd-help-mouse-drag-and-drop'.  The command
     'idd-help-mouse-drag-and-drop' is bound during the loading of the
     package 'internal-drag-and-drop' to these keys in the global
     keymap.

     Set it to 'nil' if you don't want to bind this function during
     loading.

     If the command is already bound in the global keymap during
     loading, then this key sequence will not be bound.

     By default the mouse binding is <meta> <control> <button3>.

   * 'idd-drag-and-drop-mouse-binding-type': The type of the drag and
     drop mouse binding.  The value may be 'click' or
     'press-button-during-move'.  A value of 'click' means that you have
     to click over the source, release the button and click it again
     over the destination.  A value of 'press-button-during-move' means
     that you have to press the button down over the source and hold it
     until the mouse pointer is over the destination.

     The _disadvantage_ of the 'press-button-during-move' type compared
     with the 'click' type is that you can't select a destination
     region, and therefore a drag and drop action depending on a
     selected region can't be started with that type of mouse binding.

8.1.3 The Drag And Drop Mouse Pointer
-------------------------------------

In the XEmacs the mouse pointer glyph (shape) can be set to any glyph.
This is used during the drag and drop command to indicate, that the
command is active.  There exists the following three variables to
customize this:

   * 'idd-mouse-pointer-image': The name of the xbm file with the mouse
     pointer image.  By default this is the file 'drop'.  There exists
     also a file called 'dropmsk', which contains the mask image.  The
     mask file is loaded automatically.

   * 'idd-data-directory': The name fo the directory, where the file
     'idd-mouse-pointer-image' is searched.  By default this is the
     subdirectory 'idd' in the XEmacs install directory
     'data-directory'.

   * 'idd-overwrite-mouse-pointers': A list with pointer glyph
     variables, which should be overwritten by the
     'idd-drag-and-drop-pointer-glyph'.  If it is nil, the pointer wont
     be changed.  Currently it must be nil in the Emacs.

   If one of the variables 'idd-mouse-pointer-image' or
'idd-data-directory' is changed, the command
'idd-make-drag-and-drop-pointer-glyph' must be called.  This command
builds the mouse pointer glyph, which is stored in
'idd-drag-and-drop-pointer-glyph'.

   I don't know how to set the mouse pointer in the Emacs to a drag and
drop image.  Any hints for doing this are welcome.

8.2 The Drag And Drop Commands
==============================

There are 2 groups of commands.  The first contains commands which
perform the drag and drop action and the second displays help messages
about a possible drag and drop action.

8.2.1 Performing The Drag And Drop Action
-----------------------------------------

The following five commands perform internal drag and drop actions:

   * 'idd-mouse-drag-and-drop': Performs a drag and drop action.  It
     calls the command 'idd-mouse-drag-and-drop-click' or
     'idd-mouse-drag-and-drop-press-button-during-move' depending on the
     value of 'idd-drag-and-drop-mouse-binding-type'.  However you've
     set this, you start a drag and drop action with this command by
     pressing down its mouse button over the source.  This command is
     bound by default to a global mouse key sequence.  See The Mouse Bindings.

   * 'idd-start-mouse-drag-and-drop': Starts a drag and drop command.
     This command could be used to start a drag and drop command without
     a button event.  Therefore this should not be bound directly to a
     mouse button.  This command can be used to start a drag and drop
     action with a click on a menu item or tool bar icon.  After that
     you have to press a mouse button over the source.  The rest depends
     on the value of 'idd-drag-and-drop-mouse-binding-type', as with the
     command 'idd-mouse-drag-and-drop'.

   * 'idd-help-start-action': It is possible to display a help buffer
     with a message in it, which describes the action instead of
     performing it immediately (see Displaying Help On Drag And Drop).
     In this case you can perform the action by clicking on a
     special extent in the help buffer, which runs this command.

   * 'idd-mouse-drag-and-drop-press-button-during-move': Performs a drag
     and drop action in a more traditional way than
     'idd-mouse-drag-and-drop-click'.  First you press the button over
     the source and then move with the depressed button to the
     destination, where you release the button.  This must be bound to a
     mouse button.  The 'SOURCE-EVENT' must be a 'button-press-event'.

     The disadvantage of this command compared with the command
     'idd-mouse-drag-and-drop-click' is, that you can't select a
     destination region.

     You should bind the command 'idd-mouse-drag-and-drop' instead of
     this one, because it's then possible to switch between both drag
     and drop behaviours by changing only one variable.

   * 'idd-mouse-drag-and-drop-click': Performs a drag and drop action in
     a more useful way than
     'idd-mouse-drag-and-drop-press-button-during-move'.  First you
     click on the source and then on the destination.  This must be
     bound to a mouse button.  The 'SOURCE-EVENT' must be a
     'button-press-event'.

     You should bind the command 'idd-mouse-drag-and-drop' instead of
     this one, because it's then possible to switch between both drag
     and drop behaviours by changing only one variable.

8.2.2 Displaying Help On Drag And Drop
--------------------------------------

It's possible to display a buffer with a help message describing the
action being considered before actually performing it.  To perform the
action, you then click on a special extent in the help buffer.  To get
the help buffer, you do the same things as you do to perform the action
itself.  Only the mouse key differs.  There are two commands for this:

   * 'idd-help-mouse-drag-and-drop': Displays help about the drag and
     drop action.  It works similarly to 'idd-mouse-drag-and-drop'
     (see Performing The Drag And Drop Action).

     By default this command is globally bound to <meta> <control>
     <button3>.  This may be changed with the variable
     'idd-global-help-mouse-keys' (see The Mouse Bindings).

   * 'idd-start-help-mouse-drag-and-drop': Starts displaying help about
     the drag and drop action.  It works similarly to
     'idd-start-mouse-drag-and-drop' (see Performing The Drag And Drop Action)
     and can be used to start the help by clicking on a menu
     item or a tool bar icon.

9 Template Minor Mode
*********************

There's a file called 'tmpl-minor-mode.el' in the distribution of the
package _hm--html-menus_.  It provides functions to use templates for
the 'hm--html-mode' and also for other modes.  It needs nothing from the
rest of the package and therefore it can be used independently of
'hm--html-mode'.

9.1 What Are Templates
======================

Templates are special pieces of text, which can be expanded by emacs.
Expansion means that the template is replaced by something else,
determined by evaluating lisp forms or emacs commands.  The expansion
can be done automatically after the insertion of templates with the
command 'tmpl-insert-template-file' in a buffer or by hand with the
commands 'tmpl-expand-templates-in-buffer' or
'tmpl-expand-templates-in-region'.

   Templates can be put together with normal text in a so called
template file to provide prototype files.  You should name these files
with the following naming scheme:

             <FILE>.<TYPE>.tmpl

   where <FILE> is a string which describes for what the template could
be used and <TYPE> the normal file extension, e.g.  'c' for C- files or
'html' for HTML- files.

9.2 Syntax Of Templates
=======================

The templates are marked with the sign ^@, which stands for the null
character (\000).  It can be inserted in a buffer with the keys 'C-q
C-SPC'.  You can also use any other character or string of characters by
changing the variable 'tmpl-sign'.

   At the moment, there are 3 major types of templates:

  1. _Emacs Lisp function templates_: The expansion of such a template
     evals a lisp form.  It is possible to use functions or variables as
     lisp forms.  The following is a simple example:

          ^@LISP^@ (insert-file "~/.emacs") ^@END LISP^@

     inserts the contents of the file '~/.emacs' in the current buffer
     during the expansion.

  2. _Emacs command templates_: The expansion of a command template
     evals a template in the same way as an interactive command, which
     is invoked with 'M-x command'.  For example:

          ^@COMMAND^@ insert-file ^@END COMMAND^@

     runs the interactive command 'insert-file' during the expansion.

  3. _Template comments_ Nothing will be evaluated during the expansion
     of a template comment.  It is only a comment.  For example:

          ^@C^@ This is a comment

     The end of the comment is the end of the line.  Therefore it has
     the same syntax as a lisp or C++ comment.

  4. _Point template_ After expanding the templates of a region (or the
     whole buffer), the point will be set at the beginning of this
     template, if such a template was in the region.  You should use
     only one of these templates in a region, otherwise the behaviour is
     undefined.

          The point should be here^@POINT^@ after the expansion of the region.

   By default, a template will be deleted after its expansion, but
without the linefeed.  Look at the following examples:

   Before the expansion:

         Line before the template
         ^@C^@ The Text of a comment template
         Line after the template

   After the expansion:

   Line before the template

   Line after the template

   Templates can start in any column, and only the template will be
deleted after its expansion.

   It is also possible to put an attribute list in a template.  The
attributes of the list control the deletion of the template.  It may be
that this will be extended in the future with other attributes.  The
attribute list must be specified as an alist (assoc list) in the start
tag of a template and after its type.  Each element of the alist
consists of the name of the attribute following its value.  If no
attribute list is specified or if an attribute is missing, then the
default values are used.  At the moment there are the following 2
attributes:

  1. _don't delete attribute_ ('DONT_DELETE'): If the value is t, then
     the template will not be deleted after its expansion.  If the value
     is nil then the template will be deleted.  The default is nil.  For
     example:

     Before the expansion:

              Line before the template
              ^@LISP ((DONT-DELETE t))^@ (insert-file "~/.cshrc") ^@END LISP^@
              Line after the template

     After the expansion:

              Line before the template
              ^@LISP ((DONT-DELETE t))^@ (insert-file "~/.cshrc") ^@END LISP^@
              Line after the template

     It was assumed, that the file '~/.cshrc' was empty !

  2. _delete line attribute_ ('DELETE-LINE'): If the value is t, then
     the linefeed before or after the template will be deleted.  If the
     value is nil then no linefeed will be deleted.  The default is nil.
     For example:

     Before the expansion:

              Line before the template
              ^@LISP ((DELETE-LINE t))^@ (insert-file "~/.cshrc") ^@END LISP^@
              Line after the template

     After the expansion:

              Line before the template
              Line after the template

     It was assumed, that the file '~/.cshrc' was empty !

   These attributes can be combined.  For example:

     	^@COMMAND ((DELETE-LINE t) (DONT-DELETE nil))^@
     	insert-file
     	^@END COMMAND^@

   The last examples show also that whitespace (blanks, tabs, linefeeds)
is allowed at most positions in a template.

   Look at the file 'tmpl-minor-mode.el' for a description of the
commands to expand templates.

9.3 Template Customization
==========================

Since the XEmacs 19.15 and 20.2 a special package can be used for the
customization of lisp packages.  The internal drag and drop package uses
now also this feature.  Therefore you can set all user variables with
the help of the Customize submenu, which can be selected in the Option
menu.  If you use it, the variables will currently be saved in a special
customization file.  Please look at the 'NEWS' file or the info manuals
of the XEmacs to find out more about the customization package.

   Templates may be used for all editing modes, not only for
'hm--html-mode'.  Therefore their general customization isn't done in
'hm--html-configuration.el'.  Template variables are defined in the file
'tmpl-minor-mode.el' instead.  You can set them in your '.emacs' or in
one of the other emacs init files (e.g.  'default.el').  The following
are the main variables for customization.

   * 'tmpl-template-dir-list': A list of directories with template
     files.  If it is nil, the default-directory will be used.  If more
     than one directory is specified, then the template filenames should
     differ in all directories.

     This variable is used in the commands for inserting templates.
     Look at 'tmpl-insert-template-file-from-fixed-dirs' and at
     'tmpl-insert-template-file'.  The command
     'tmpl-insert-template-file' uses only the car of the list (if it is
     a list.)
   * 'tmpl-template-configuration-file': Name of the configuration file
     for the tmpl minor mode.  Its a name without a directory, because
     the file will be searched in all upper directories, until it (one)
     is found.  The file must contain loadable Lisp code.

     If the command 'tmpl-insert-template-file-from-fixed-dirs' is
     called, and the variable 'tmpl-template-dir-list' is nil, the file
     determined by the variable 'tmpl-template-configuration-file' will
     be searched in all upper directories and in the default one,
     starting with the default directory.  If such a file is found and
     readable, then it is loaded.  Therefore you can set the variable
     'tmpl-template-dir-list', if you insert a line like the following
     in such a file:

     '(setq tmpl-template-dir-list
     '("~/data/docs/latex/teTeX/templates/"))'

   * 'tmpl-filter-regexp': This defines a regular expression used for
     filtering out non-template files in template directories.  It is
     used in the command 'tmpl-insert-template-file-from-fixed-dirs' to
     allow only the selection of files which match the regexp.  If it is
     nil, then the Filter '".*\\.tmpl$"' is used.  Set it to '\".*\"' if
     you want to disable the filter function or use the command
     'tmpl-insert-template-file'.
   * 'tmpl-automatic-expand': If you insert a template file with
     'tmpl-insert-template-file-from-fixed-dirs' or with
     'tmpl-insert-template-file', this variable is used.  The templates
     in the buffer will be automatically expanded if the variable is set
     to t, which is the default.
   * 'tmpl-sign': This determines the sign which marks the beginning and
     the end of template expressions.  By default it is set to the null
     character (displayed in emacs as ^@).  You can also set this to a
     string.  Be careful if you change it, so that the templates will
     not be mixed up with other non-template text!  Note: The expansion
     function looks at the whole template, so that it is very unlikely
     that the function will make a mistake.
   * 'tmpl-minor-mode-map': The keymap for the template minor mode.

9.4 Template Commands
=====================

In this section the commands of the template package are described.

9.4.1 Insert Of Template Files
------------------------------

The template package provides the following two commands for inserting
template files in an emacs buffer.

   * 'tmpl-insert-template-file': This command can be used to insert a
     template file in the current buffer.  It will expand the templates
     in the buffer if 'tmpl-automatic-expand' is set to 't'.  You can
     set a default directory for this command by setting the variable
     'tmpl-template-dir-list'.  See Template Customization.
   * 'tmpl-insert-template-file-from-fixed-dirs': The difference from
     the simpler command 'tmpl-insert-template-file' is that this
     command will build a list for filename completion from a list of
     predefined directories (look at 'tmpl-template-dir-list').  The
     filename completion list will also be filtered with the regular
     expression defined by 'tmpl-filer-regexp'.  See Template Customization.
     You can set the directory list and/or the filter
     differently in each mode where you use templates, so that you will
     get in the completion list only template files which could be used
     for the current mode.

     If the variable 'tmpl-template-dir-list' is nil, it tries to find a
     file with a name determined by the variable
     'tmpl-template-configuration-file'.  The file is searched at first
     in the default directory, at second in it's parent directory, at
     third in the parent directory of the parent directory and so on,
     until it is found or the root directory is reached.  If such a
     readable file is found, then it is loaded.  Therefore you can set
     this variable by inserting a line like the following in such a
     file: '(setq tmpl-template-dir-list
     '("~/data/docs/latex/teTeX/templates/"))'

     If you want to insert a template file with this command, which is
     not in one of the directories from 'tmpl-template-dir-list', then
     you have to enter the string _"Change the directory"_ instead of a
     template file.  This string is also in the completion list.

   Both commands can also be used as functions.  In this case the
template file with is directory path must be given to them as an
parameter.

   You can also use commands like 'insert-file' to insert template files
and expand them by hand (see Expansion Of Templates).

9.4.2 Expansion Of Templates
----------------------------

You can expand templates by hand or automatically after their insertion.
See Insert Of Template Files, for automatic expansion.  Expansion by
hand can be done with one of the following two functions:

   * 'tmpl-expand-templates-in-region': Expands the templates in the
     region.  The region is established by the optional arguments
     'BEGIN' and 'END'.  If the arguments are 'nil', or if the function
     is called interactively, then the current region will be used.
   * 'tmpl-expand-templates-in-buffer': Expands all templates in the
     current buffer.

   Both commands are bound to keys in the 'tmpl-minor-mode'.  See The Template Minor Mode.

9.4.3 Escaping Of Template Signs
--------------------------------

It is possible to escape template signs in a buffer or in a region.
Templates with escaped template signs are not expanded, but they are
un-escaped by the expansion functions.  Therefore it is possible to
exclude single templates from the expansion by escaping them.  Note: You
can't escape a template twice.  The commands which can be used for this
are:

   * 'tmpl-escape-tmpl-sign-in-region': Escapes all 'tmpl-sign's (see
     Template Customization) with a 'tmpl-sign' in a region.  The
     region is established by the optional arguments 'BEGIN' and 'END'.
     If the arguments are 'nil', or if the function is called
     interactively, then the current region will be used.
   * 'tmpl-escape-tmpl-sign-in-buffer': Same as
     'tmpl-escape-tmpl-sign-in-region', but escapes all templates in the
     whole buffer.

   Both commands are bound to keys in 'tmpl-minor-mode'.  See The Template Minor Mode.

9.4.4 The Template Minor Mode
-----------------------------

The template minor mode can be toggled with the command
'tmpl-minor-mode'.  The purpose of this mode is only to provide key
bindings for some of the commands of the package 'tmpl-minor-mode'.  If
you don't want to use the key bindings, you don't need this minor mode.

   Look at the key table 'tmpl-minor-mode-map' (see Template Customization)
for the definition of the keys.

   It may be that I'll also provide a pulldown or popup menu for the
minor mode in a future release.

10 Hints For Emacs 19 Users
***************************

This package is tested with the GNU Emacs 19.34.  The Emacs 19.34 has
had not all features of the XEmacs.  Therefore also some of the features
of this package could not be implemeted in the Emacs 19.

   Please read also the Emacs 19 related file 'README-EMACS-19'!

   The following is a list of missing features:

   * The capability to start an action from the help buffer.  This is
     only possible in the XEmacs, because in the Emacs 19.34 one can't
     assign keymaps to a text region (overlay).

   * The keybindings of the drag and drop commands are not displayed in
     the menus, because the Emacs 19 isn't able to handle the following
     menu specification: ':keys "\\[idd-help-mouse-drag-and-drop]"'.

   * The function 'file-remote-p' couldn't be implemeted, because of the
     lack of the function 'ange-ftp-ftp-p' in the ange-ftp package of
     the Emacs 19.34.

   * The history variable determined by 'tmpl-history-variable-name'
     isn't used, because the function 'read-file-name' doesn't support
     it in the Emacs 19.

   * The mouse pointer shape (glyph) wont be changed in the Emacs 19
     during a drag and drop command.  For that a way is needed to set
     the mouse pointer shape to an image.

11 Bug Reports
**************

There's no software out there without bugs.  This package contains
software, therefore it has bugs.  I (Heiko Münkel
<muenkel@tnt.uni-hannover.de>) have inserted most of the bugs in this
package by myself, but I've forgotten where.  So please help me out of
this disaster and send bug reports, if you've found one of these little
animals.  I'll try to do my very best to fix them and to insert new
ones.

   If it's possible, you should use the command

             M-x hm--html-submit-bug-report

   There's also an entry in the pulldown menu for this.

   In some cases a backtrace would also be appropriate.

   If you can't send the report with this function, at least include the
package version and your 'Emacs'/'XEmacs' version.

   In the best of all worlds you would also include a patch to fix the
bug.

   _Note_: It's not true that I've inserted the bugs as a marketing
trick, so that you must buy the next version to get some of them fixed.
This is false, because this software is free.